Inhalt

BESTVIEW

by Softing AG

Debugger für BEST/2 Beschreibungsdateien.


Auswahl einer Beschreibungsdatei

Beschreibungsdateien werden mit dem Menu File Open ausgewählt. Es können sowohl BEST/2-Quelldateien ( mit der Endung .B2V oder .B2G ), BEST/1-Quelldateien ( mit der Endung .B1V oder .B1G ) als auch ausführbare Objektdateien ( mit der Endung .PRG oder .GRP ) geöffnet werden. Eine Beschreibungsdatei kann auch mittels Drag&Drop geöffnet werden, hierzu ist die zu öffnende Beschreibungsdatei vom Explorer in den Arbeitsbereich von BestView zu ziehen.

Nur wenn eine BEST/2-Quelldatei geöffnet wird, besteht die Möglichkeit zu debuggen. Bei einer BEST/1-Quelldatei oder einer Objektdatei können die Jobs nur ausgeführt werden.

Wird eine Quelldatei gewählt, so sucht BestView die entsprechende Objektdatei in dem mit der Option ECU-Directory ausgewählten Directory. Ist dies nicht gewünscht kann man in der Option ECU-Directory diese auf '.' setzen. Dann sucht BestView die Objektdatei im Verzeichnis der Quelldatei. Eine Änderung des ECU-Directory ist nur möglich, wenn in BestView keine Beschreibungsdatei geladen ist.

Wird eine Objektdatei ausgewählt, so verhält sich BestView wie das normale EDIABAS Laufzeitsystem. Bei Auswahl einer Gruppe wird der Job IDENTIFIKATION in der Gruppendatei automatisch ausgeführt, und erst dann der ausgesuchte JOB in der dadurch bestimmten Variantendatei. Bei Auswahl einer Quelldatei verhält sich eine Gruppenbeschreibungsdatei wie eine Variantenbeschreibungsdatei, d.h. der Job IDENTIFIKATION hat keine besondere Bedeutung und kann jederzeit untersucht werden.

Nach dem Öffnen einer Beschreibungsdatei wird diese in einem Source-Window angezeigt, bei Auswahl einer Objektdatei wird hingegen nur ein minimiertes Objekt-Window angezeigt. Einer Beschreibungsdatei können mehrere BEST/2-Quelldateien (Moduln) zugrundeliegen. Über das Menu File View kann die Anzeige zwischen den jeweiligen Moduln umgeschaltet werden.

BestView ermöglicht das automatische Öffnen eines Projekt-Windows, welches alle Jobs und BEST/2-Quelldateien (Moduln) der geladenen Beschreibungsdatie darstellt. Das Projekt-Window kann als Mini-Window oder Docking-Window verwendet werden. Die Mini-Window-Darstellung ermöglicht die Positionierung des Mini-Windows in jeden Bereich des Windows-Desktops, der Arbeitsbereich von BestView bleibt hiervon unbeeinflußt. Bei der Docking-Window-Darstellung wird der Arbeitsbereich von BestView entsprechend der Docking-Ausrichtung (links, rechts, oben, unten) automatisch verkleinert. Durch Doppel-Click auf den Projekt-Window-Rand ist eine Umschaltung zwischen Mini- und Docking- Darstellung möglich. Über das Menu Window Projekt kann das Projekt-Window zu- oder abgeschaltet werden.

Die Bindung des Debuggers an eine Beschreibungsdatei bleibt solange erhalten, bis diese mit dem Menu File Close verworfen, das Beschreibungsdatei-Window geschlossen oder eine Beschreibungsdatei neu ausgewählt wird.

Besteht eine Beschreibungsdatei aus mehreren Moduln (die mit File Open geöffnetete B2V-Datei + Include-Dateien), so wird für die Include-Datei-Suche der gleiche Suchalgorithmus angewendet wie beim BEST/2-Compiler:

Bei #include-Anweisungen mit absoluten oder relativen Pfadangaben sucht BestView nur in den vorgegebenen Pfaden nach der jeweiligen Include-Datei. Bei relativen Pfadangaben bezieht sich die Pfadangabe immer auf das Verzeichnis der mit File Open geöffneten B2V-Datei (Source-Verzeichnis).

Bei #include-Anweisungen ohne Pfadangaben sucht BestView zuerst im Verzeichnis der mit File Open geöffneten B2V-Datei nach der jeweiligen Include-Datei. Über das Menu Options Include-Path kann die Suche auf zusätzliche Verzeichnisse ausgedehnt werden.


Aktualisierung einer Beschreibungsdatei

Die Änderung einer Beschreibungsdatei ohne zwischenzeitlichem Verlassen des Debuggers erfordert die Aktualisierung der Beschreibungsdatei.

Die Aktualisierung der Beschreibungsdatei ist einfach durch die erneute Auswahl der bereits geladenen Beschreibungsdatei mit dem Menu File Open durchzuführen.

Als zu ladende Datei ist die bereits als Voreinstellung angebotene Datei zu wählen.


Selektieren eines Jobs

Die Auswahl eines Jobs geschieht mit dem Menupunkt Job im Menu Run. Es werden alle vorhanden Jobs der gewählten Beschreibungsdatei angezeigt. Es kann auch der Job INITIALISIERUNG ausgewählt werden. In Gruppenbeschreibungsdateien ist auch die Auswahl des Jobs IDENTIFIKATION möglich.

Wurde eine Gruppenbeschreibungsdatei als Objektfile geöffnet, so betrifft der eingegeben Jobname die Variantendatei und nicht die Gruppdendatei.

Der auszuführende Job kann über folgende Eingaben konfiguriert werden:

Job-Parameter

Die hier eingegebenen Daten werden später an den auszuführenden Job übergeben. Bei der Einstellung String werden die Job-Parameter 1:1 an den Job übergeben. Bei der Einstellung Data werden die Job-Parameter vor der Job-Ausführung in einen entsprechenden binären Datenstrom konvertiert und so an den Job übergeben.

Bei Eingabe von binären Daten ist folgende Syntax notwendig:

hex,hex,hex,...

Alternativ zur direkten Eingabe binärer Daten kann der Job auch mit binären Daten versorgt werden, welche in einer eigenen Textdatei spezifiziert sind. Durch Angabe von @<Textdateiname> wird bei Ausführung des Jobs die Textdatei eingelesen, in einen entsprechenden binären Datenstrom konvertiert und so an den Job übergeben. Die Textdatei muß hierzu folgendes Format aufweisen:

hex,hex,hex,hex,hex,hex,hex,hex

hex,hex,...

Standardjob-Parameter

Die hier eingegebenen Daten werden später an die Standardjobs übergeben, welche von BestView automatisch abgearbeitet werden.

Die Eingabemöglichkeiten sind identisch mit den Eingabemöglichkeiten der eigentlichen Job-Parameter.

Job-Ergebnisse

Hier kann eine Auswahl der vom Job zu generierenden Jobs getroffen werden. Diese Funktionalität muß von der Beschreibungsdatei unterstützt werden.

Der Job generiert alle Ergebnisse, wenn in diesem Eingabefeld nichts eingegeben wird.

Initialisierung der Beschreibungsdatei

Diese Eingabe ermöglicht die automatische Durchführung des Jobs INITIALISIERUNG unmittelbar vor der Ausführung des ausgewählten Jobs. Nach Laden einer Beschreibungsdatei, Auftreten eines Fehlers oder bei Abbruch eines Jobs ist die Durchführung des Jobs INITIALISIERUNG immer notwendig.

BestView speichert die letzten 4 Job-Namen incl. aller Job-Konfigurationen. Über die Drop-Down-Liste kann ein vorhergehender Job mit den entsprechenden Job-Konfigurationen ausgewählt werden.

Der Job kann direkt aus dieser Dialogbox heraus gestartet werden.


Setzen von Breakpoints

Breakpoints werden im Source-Window gesetzt.

Dazu wird der Cursor im Source-Window auf die Zeile gesetzt, in der der Breakpoint erscheinen soll. Dazu kann auch die Maus benutzt werden. ein Click mit der linken Maustaste setzt den Cursor an Stelle des Mauszeigers.

Mit der Taste F9 wird der Breakpoint in dieser Zeile aktiviert. Die Zeile bekommt eine andere Farbe. Mit einem weiteren Druck auf die Taste F9 wird der Breakpoint wieder deaktiviert.

Das Setzen und Löschen von Breakpoints kann auch mit der Maus geschehen. Dazu den Mauszeiger auf die betreffende Zeile setzen. Ein Doppelklick mit der linken Maustaste aktiviert bzw. deaktiviert den Breakpoint in dieser Zeile.

Mit dem Menuepunkt Clear Breakpoints werden alle Breakpoints gelöscht.


Abarbeitung eines Jobs

Vor der Abarbeitung eines Jobs wird eine Initialisierung der Beschreibungsdatei vorgenommen, wenn dies bei der Job-Auswahl vorgegeben wurde. Hierzu wird das EDIABAS-Laufzeitsystem initialisiert und der Job INITIALISIERUNG durchlaufen.

Jobs können auf drei verschiedene Arten abgearbeitet werden:

Go

Arbeitet den Job ab, bis entweder ein Breakpoint, oder das Ende das Jobs erreicht wurde.

Step

Arbeitet den Job bis zur nächsten gültigen Zeile oder dem Jobende ab.

Continue to Cursor

Arbeitet den Job bis zur aktuellen Cursorstelle ab. An dieser Stelle muß das Setzen eines Breakpoints möglich sein. Trifft die Abarbeitung vorher auf einen Breakpoint, so wird dort abgebrochen.

Zusätzlich besteht die Möglichkeit, durch Doppel-Click auf einen Job-Namen im Projekt-Window den entsprechenden Job zu starten. Bei unbekannter Job-Konfiguration wird stattdessen der Job-Auswahldialog angezeigt.

Der aktuelle Bearbeitungspunkt wird durch eine farbige Zeile gekennzeichnet. Die gekennzeichnete Zeile ist zu diesem Zeitpunkt noch nicht bearbeitet.


Anzeigen und Veraendern von Variablen

Anzeigen und Verändern von Variablen

Variable, Ergebnisse und Parameter können mit dem Menupunkt Show Data im Menue Debug angezeigt werden.

Es erscheint eine Dialogbox, in der die Art der anzuzeigenden Daten ausgewählt werden kann. Bei den Ergebnissen muß zusätzlich zum Namen noch der gewünschte Ergebnissatz ausgewählt werden.

Alle Daten werden als Wert und als binäre Daten angezeigt. Das Anzeigeformat des Wertes kann den Möglichkeiten entsprechend angepasst werden.

Ist der angezeigte Wert eine Variable so kann er aus der Dialogbox heraus durch Klicken des Buttons Modify ebenso mit dem Befehl Modify Variable aus dem Menue Debug in einer eigenen Dialogbox verändert werden.

Eine Variable kann während des Debuggens in einem eigenen Fenster laufend beobachtet werden, indem sie mit dem Befehl Watch Variable aus dem Menue Debug, in die Watchliste aufgenommen wird. Dort kann sie auch wieder entfernt werden.

Variable und Parameter werden automatisch angezeigt, wenn die Maus im Source-Window auf eine Variable oder einen Parameter zeigt. Data-Variable werden in hexadezimaler Form ausgegeben, wobei die Anzeige auf max. 32 Byte beschränkt ist.


Das Menu File

Das Menue File

Open

Öffnen einer Beschreibungsdatei.

Es können sowohl Quelldateien als auch Objektdateien geöffnet werden. Nur wenn eine BEST/2-Quelldatei geöffnet wird, besteht die Möglichkeit zu debuggen. Bei einer BEST/1-Quelldatei oder einer Objektdatei können die Jobs nur ausgeführt werden.

Bei Auswahl einer Quelldatei wird die Objektdatei entsprechend des konfigurierten ECU-Directory gesucht. Soll das ECU-Directory immer dem Quelldatei-Verzeichnis entsprechen, so ist im Menu Options das Directory auf '.' zu setzen.

Close

Schliessen der geladenen Beschreibungsdatei.

Die Bindung des Debuggers mit der geladenen Beschreibungsdatei wird aufgelöst.

Solange eine Beschreibungsdatei geladen ist, darf diese nicht geändert werden. Das Öffnen der Beschreibungsdatei als auch das Verlassen des Debuggers bewirken das automatische Verwerfen der geladenen Beschreibungsdatei.

View

Steuerung des anzuzeigenden Moduls

Falls eine Beschreibungsdatei aus mehreren BEST/2-Quelldateien (Moduln) besteht, kann hierüber ein anderes Modul der Beschreibungsdatei angezeigt werden.

Die Anzeige des anzuzeigenden Moduls kann auch über das Projekt-Window gewechselt werden.

Exit

Verlassen des Debuggers.


Das Menu Edit

Das Menue Edit

Copy

Kopieren des selektierten Textes des aktiven Windows in die Zwischenablage.

Select All

Selektieren des gesamten Textes des aktiven Windows.

Find

Suchen eines Textes im aktiven Window. Durch Aktivieren der Match Uppercase/Lowercase-Option müssen Groß/Klein-Schreibung des gesuchten Textes exakt übereinstimmen.

Die Textsuche beginnt an der aktuellen Cursorposition.

Find Next

Die letzte Textsuche wird an der aktuellen Cursorposition fortgesetzt.

Goto Line

Sprung auf eine bestimmte Textzeile.

Durch Eingabe der gewünschten Zeilennummer kann auf die entsprechende Textzeile in der Quelldatei gesprungen werden.


Das Menu Run

Das Menue Run

Job

Auswahl des abzuarbeitenden Jobs.

Es können alle in der Beschreibungsdatei vorhandenen Jobs angewählt werden. Zusätzlich können die Jobparameter und gewünschten Ergebnisse angegeben werden. Mit dem Button Go können die Jobs sofort gestartet werden.

Go

Begin oder Wiederaufnahme der Jobbearbeitung.

Arbeitet den Job ab, bis entweder ein Breakpoint oder das Ende das Jobs erreicht wurde.

Continue to Cursor

Begin oder Wiederaufnahme der Jobbearbeitung.

Arbeitet den Job bis zur aktuellen Cursorstelle ab. An dieser Stelle muß das Setzen eines Breakpoints möglich sein. Trifft die Abarbeitung vorher auf einen Breakpoint, so wird dort abgebrochen.

Step

Beginn oder Wiederaufnahme der Jobbearbeitung.

Arbeitet den Job bis zur nächsten gültigen Zeile, oder dem Jobende ab.

Restart

Neubegin des ausgewählten Jobs

Ermöglicht den Neustart eines Jobs, falls dessen Abarbeitung noch nicht beendet wurde.


Das Menu Debug

Das Menue Debug

Toggle Breakpoint

Setzen oder Rücksetzen eines Breakpoints.

Falls in der aktuellen Zeile kein Breakpoint gesetzt ist, so wird jetzt ein Breakpoint gesetzt. Ist jedoch bereits ein Breakpoint gesetzt so wird dieser gelöscht.

Das gleiche bewirkt ein Doppelklick mit der linken Maustaste auf die betreffende Zeile.

Ist das Setzen eines Breakpoints nich möglich, so ertönt ein Signal.

Clear Breakpoints

Löschen aller Breakpoints.

Show Data

Anzeigen einer Variable, eines Parameters oder eines Ergebnisses.

Es erscheint eine Dialogbox, in der die Werte der aller momentan gültigen Variablen, Parameter oder Ergebnisse und ihre binäre Repräsentation anzeigt werden können.

Aus dieser Dialogbox können die Werte der Variablen auch verändert werden.

Modify Variable

Anzeigen und Verändern einer Variable.

Alle momentan gültigen Variablen können angezeigt und verändert werden. Es erscheint eine Dialogbox, in der der Wert der Variablen und ihre binäre Repräsentation angzeigt wird.

Bei einfachen Variablen ( keine Arrays ) kann der Wert der Variablen in dezimaler-, hexadezimaler oder ASCII-Darstellung erfolgen.

Der Wert der Variablen kann in allen drei Darstellung verändert werden. Durch Drücken der Taste Update wird die binäre Darstellung aktualisiert.

Die Variable kann auch in der binären Darstellung verändert werden, jedoch ist auf die Wahrung des Anzeigeformats zu achten.

Durch Drücken der Taste OK oder Return wird der geänderte Variableninhalt übernommen.

Die Tasten Cancel oder ESC wird der Vorgang ohne Änderung der Variable beendet.

Watch Variable

Beobachten einer Variable

Die Werte ausgewählter Variablen werden in einem eigenem Fenster angezeigt und laufend, d.h. nach jedem Step, aktualisiert.


Das Menu Window

Das Menue Window

Project

Projekt-Window anzeigen oder schließen.

Watch

Watch-Window anzeigen oder schließen.

IFH Trace

IFH-Trace-Window anzeigen oder schließen.

Cascade

Arrangieren der Windows in Form eines Kartenstapels.

Tile Horizontally

Gleichmäßiges horzontales Teilen der Windows mit Ausnahme der minimierten Windows.

Tile Vertically

Gleichmäßiges vertikales Teilen der Windows mit Ausnahme der minimierten Windows.

Windows

Hier werden alle angezeigten Windows aufgelistet.


Das Menu Help

Das Menue Help

Contents

Ruft diesen Hilfstext mit seiner Inhaltsseite auf.

Index

Ruft diesen Hilfstext mit seinem Suchdialog auf.

About

Anzeigen der Versionsnummern von Bestview und EDIABAS.


Toolbar

File-Open

Run-Job

Run-Go

Run-Step

Debug-Toggle Breakpoint

Debug-Show Data

Debug-Watch Variable

Window-IFH Trace

Options-IFH Trace

Edit-Find

Edit-Find Next

Help-Contents


Abkuerzungstasten

Abkürzungstasten

F1 Help-Contents

F3 File-Open

Shift+F3 File-View

Alt+F4 File-Exit

Ctrl+C Edit-Copy

F4 Edit-Find Next

F5 Run-Go

Ctrl+F5 Run-Job

F7 Run-Continue To Cursor

F8 Run-Step

F9 Debug-Toggle Breakpoint

Shift+F9 Debug-Show Data

Ctrl+F9 Debug-Modify Variable

Alt+F9 Debug-Watch Variable


Kommandozeile

BestView kann wie folgt mit Kommandozeileparametern versorgt werden:

BESTVW32.EXE [File] [EcuDir]

File Name des Quell- oder Objectfiles, das ausgeführt werden soll.

EcuDir Das zu verwendende ECU-Directory


AboutBox

BESTVIEW

Copyright BMW AG, created by Softing AG.


Das Menu Options

Das Menue Options

ECU-Directory

Hier kann das Directory eingestellt werden, in dem der Debugger die Objektdateien sucht. Wenn der Debugger dem Source-Directory folgen soll, so ist hier ein . einzutragen.

Bei Aktivierung der Option Use EDIABAS Configuration wird das über die EDIABAS-Konfigurationsdatei EDIABAS.INI gewählte ECU-Directory verwendet.

Include-Path

Hier können zusätzliche Verzeichnisse angegeben werden, in welchen BestView nach Include-Dateien sucht. Mehrere Verzeichnisse sind mit : zu trennen. Die Suche beginnt immer im Verzeichnis der mit File Open geöffneten BEST/2-Quelldatei. Anschließend wird der Include-Pfad - von links nach rechts - durchsucht.

Bei #include-Anweisungen mit absoluten oder relativen Pfaden wird der Include-Pfad nicht berücksichtigt.

Device

Hier kann das Kommunikationsdevice fuer EDIABAS eingestellt werden.

ECU Simulation

Hier kann die Steuergeräte-Simulation ein- oder ausgeschaltet werden, die EDIABAS-Konfigurationsdatei EDIABAS.INI bleibt unverändert. In der Statuszeile wird auf eine aktivierte Steuergeräte-Simulation hingewiesen.

IFH Trace

Hier kann der IFH-Trace-Level eingegeben und der IFH-Trace entsprechend ein- oder ausgeschaltet werden, die EDIABAS-Konfigurationsdatei EDIABAS.INI bleibt unverändert. In der Statuszeile wird auf einen aktivierten IFH-Trace hingewiesen.

Der IFH-Trace kann über das Menu Window IFH Trace angezeigt werden.

Über den Button Delete File kann die IFH-Trace-Datei gelöscht bzw. zurückgesetzt werden.

Auto Job Selection

Falls diese Option aktiviert ist wird automatisch nach dem Öffnen einer Beschreibungsdatei das Menu Run Job ausgeführt.


BEST/2

BEschreibungssprache für STeuergeräte Version 2.


Modul

Eine Beschreibungsdatei kann aus mehreren Moduln bestehen: die mit File Open geöffnete BEST/2-Quelldatei sowie ein oder mehrere Include-Dateien.


BEST/2 Compiler

Dient zum Übersetzen von BEST/2 Quelldateien in Objektdateien.


Job

Teil einer Beschreibungsdatei, der gleich einer Funktion, diese in funktionelle Blöcke teilt. Jeder Job kann beliebig viele Ergebnisse zurückliefern.


Breakpoint

Zeile an der die Bearbeitung eines Jobs unterbrochen werden soll.


Beschreibungsdatei

Datei die alle Informationen zur Übersetzung von steuergerätespezifischen Daten in steuergeräteunabhängige Daten enthält. Es gibt Quelldateien ( mit der Endung .B2V oder .B2G ) und ausführbare Objektdateien ( mit der Endung .PRG oder .GRP ). Objektdateien werden mit Hilfe des BEST/2 Compilers aus den Quelldateien erstellt.